package artificialLifeSimulator.abstractClasses;

import java.io.Serializable;

import javafx.scene.canvas.GraphicsContext;
/**
 * @author Toni
 * Class defines methods that are used to simulate the changes of the habitat
 */
public abstract class AbstractHabitat  implements Serializable{

	
	/**
	 * Method is used to simulate changes of the habitat during time in the ecosystem, which are represented as iterations
	 */
	public abstract void nextIteration();
	

	/**
	 * Method is used to create a full copy of the habitat
	 * @return copy of the habitat
	 */
	public abstract AbstractHabitat copyOf();
	


	/**
	 * Method is used to draw the habitat using the graphics context object
	 * @param g Graphics context used for drawing
	 */
	public abstract void drawHabitat(GraphicsContext g);
}
