package artificialLifeSimulator.GUI.controls;

import artificialLifeSimulator.GUI.parameterScenes.AbstractCarnivoreParameterScene;
import artificialLifeSimulator.GUI.parameterScenes.AbstractHabitatParameterScene;
import artificialLifeSimulator.GUI.parameterScenes.AbstractHerbivoreParameterScene;
import artificialLifeSimulator.GUI.parameterScenes.AbstractPlantParameterScene;
import artificialLifeSimulator.GUI.parameterScenes.basic.BasicHerbivoreParameterScene;
import artificialLifeSimulator.GUI.parameterScenes.basic.BasicPlantParameterScene;
import artificialLifeSimulator.abstractClasses.AbstractHabitat;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.GridPane;

/**
 * @author Toni
 * Class is used to get the parameter scenes of wanted organism implementations
 */
public class ParameterSceneFactory {

	/**
	 * Method is used to get the parameter scene of the given plant name
	 * @param lastChosenPlant name of the plant implementation whose parameter scene is wanted
	 * @return the parameter scene of given plant
	 */
	public static AbstractPlantParameterScene getPlantParameterScene(String lastChosenPlant) {
		if(lastChosenPlant == null) return null;
		switch (lastChosenPlant) {
		case "Basic Plant":
			return new BasicPlantParameterScene();
		default:
			return null;
		}
	}

	/**
	 * Method is used to get the parameter scene of the given herbivore name
	 * @param lastChosenHerbivore name of the herbivore implementation whose parameter scene is wanted
	 * @return the parameter scene of given herbivore
	 */
	public static AbstractHerbivoreParameterScene getHerbivoreParameterScene(String lastChosenHerbivore) {
		if(lastChosenHerbivore == null) return null;
		switch (lastChosenHerbivore) {
		case "Basic Herbivore":
			return new BasicHerbivoreParameterScene();
		default:
			return null;
		}

	}

	public static AbstractCarnivoreParameterScene getCarnivoreParameterScene(String lastChosenCarnivore) {
		if(lastChosenCarnivore == null) return null;
		switch (lastChosenCarnivore) {
		default:
			return null;
		}

	}
	
	public static AbstractHabitatParameterScene getHabitatScene(String lastChosenHabitat) {
		if(lastChosenHabitat == null) return null;
		switch (lastChosenHabitat) {
		default:
			return null;
		}

	}

}
