package artificialLifeSimulator.helperClasses;

import java.io.Serializable;

/**
 * @author Toni
 * Class is used to implement a basic location in 2D
 */
public class Location implements Serializable{
	private double x;
	private double y;
	
	/**
	 * Constructor for location class
	 * @param x coordinate x
	 * @param y coordinate y
	 */
	public Location(double x, double y){
		this.x = x;
		this.y = y;
	}

	/**
	 * Method is used to get the number of dimensions in this location representation
	 * @return the number of dimensions
	 */
	public int getDimension() {
		return 2;
	}

	/**
	 * Method is used to get the x coordinate
	 * @return x coordinate
	 */
	public double getX() {
		return x;
	}
	/**
	 * Method is used to get the y coordinate
	 * @return  y coordinate
	 */
	public double getY() {
		return y;
	}

	/**
	 * Method is used to set the x coordinate
	 * @param x new x coordinate
	 */
	public void setX(double x) {
		this.x = x;
	}
	/**
	 * Method is used to set the y coordinate
	 * @param y new y coordinate
	 */
	public void setY(double y) {
		this.y = y;
	}
	
	/**
	 * Method is used to set x and y coordinates
	 * @param x new x coordinate
	 * @param y new y coordinate
	 */
	public void setCoordinates(double x, double y) {
		if(x<0 || y<0){
			System.out.println();
			System.out.println(x +" " + y);
			throw new IllegalArgumentException();
		}
		this.x = x;
		this.y = y;
	}

	/**
	 * Method is used to return the copy of Location object
	 * @return copy of this Location object and all its attributes
	 */
	public Location copyOf(){
		Location copy= new Location(x,y);
		return copy;
	}
	
	@Override
	public String toString() {
		StringBuilder sb=new StringBuilder();
		sb.append("("+ x + ", "+ y+")");
		return sb.toString();
	}
}
